{% extends '@Paa/Default/menu.html.twig' %}

{% block head %}
    <meta name="description" content="{{ psLibelléTable }}">
    {{ parent() }}
{%endblock%}
 
{% block titrePage %}
    <div id="entityFormTreeview_DataNodes" style="display:none;">{{ psDataNodes }}</div>
    <div id="NomTable" style="display: none;">{{ psNomTable }}</div>
    <div id="LibelléTable" style="display: none;">{{ psLibelléTable }}</div>
    <div id="resize_wrapper" class="col-xs-12 col-sm-12 col-md-12 col-lg-12 pr-5 pl-5">
        <div class = "TitrePage pb-2 pt-3 pr-3">{{ psLibelléTable }} </div>
    </div>
{%endblock%}

{#Corps du body#}
{% block content %}
    {#Boutons#}
    
    <div class="col menu-btng shadow-sm">
        <div id="button">
            <div id="ctnBoutons_users_wrapper" class="col-sm-12">        
                {% include '@Paa/Default/entityFormBoutons.html.twig' %}
            </div>
        </div>
    </div>
            
    <div id="resize_handle" class="d-flex bg-white p-3 splite">
        
            <div class="scroller spliteA"style="height: 575px">
                <div id="entityFormTreeview_Treeview" {#style=" overflow: auto; height: 100%;"#}>
                </div>
            </div>

{#Boutons "Déplacé plus haut le 12/08/2020 par Emma "  
           
           <div class="col">
                <div id="button">
                    <div id="ctnBoutons_users_wrapper" class="col-sm-12">        
                        {% include '@Paa/Default/entityFormBoutons.html.twig' %}
                    </div>
                </div>
            </div>#}
            <div class="marginformactibase spliteB" style="height: 100%">
                <div id="formulaire_DataTable_{{ psNomTable }}" style="height: 100%">
                </div>
            </div>
        </div>
    </div>
{% endblock %}


{#Scripts qui doivent s'exécuter à la fin du body#}
{% block scriptsEnFinDeBody %}
    {{ parent() }}
    <script type="text/javascript" src="{{asset_version('Limoog/Symfony/entityForm.js')}}"></script>
    <script type="text/javascript" src="{{asset_version('Limoog/Symfony/entityFormBoutons.js')}}"></script>
    <script type="text/javascript" src="{{asset_version('Limoog/Symfony/entityFormGrille.js')}}"></script>
    <script type="text/javascript" src="{{asset_version('Limoog/Symfony/entityFormTreeview.js')}}"></script>
    <script type="text/javascript" src="{{asset_version('Limoog/Partages/widgets/LGDataTable.js')}}"></script>

    {#spectrum : widget getColor utilisé pour les colorPicker #}
    <script src="{{asset_version('vendor/spectrum/spectrum.js')}}"></script>
    <link rel="stylesheet" href="{{asset_version('vendor/spectrum/spectrum.css')}}" />
    <script type="text/javascript" src="{{asset_version('Limoog/Partages/src/couleurs.js')}}"></script>

    <script>
        $(document).ready(pageEntityFormTreeview_DocumentReady);

        function pageEntityFormTreeview_DocumentReady() {
            // Récupérer les noms et libellés de la table gérée par la grille, puis changer l'Id des zones, pour éviter les confusuions avec les sous-formulaires
            $('body').css('height', 'calc(100% - 140px)');
            var lsNomTable = $('#NomTable').text();
            var lsLibelléTable = $('#LibelléTable').text();
            $('#NomTable').prop("id", "NomTable_" + lsNomTable);
            $('#LibelléTable').prop("id", "LibelléTable_" + lsNomTable);

            // Définir l'objet de gestion combiné grille/boutons/entité
            window.entityFormTreeview = newEntityFormTreeview(lsNomTable, lsLibelléTable);

            // Générer le configurer le Treeview, et l'affecter à window.entityFormTreeview.oTreeview
            var lsDataNodes = document.getElementById("entityFormTreeview_DataNodes").textContent;
// LG 20200812 old            LGTreeview_initTree("entityFormTreeview_Treeview", lsDataNodes, window.entityFormTreeview, window.entityFormTreeview.onInitComplete);
            LGTreeview_initTree("entityFormTreeview_Treeview", lsDataNodes, window.entityFormTreeview, actiBasesTreeview_onInitComplete);
        }

// LG 20200812 début
        function actiBasesTreeview_onInitComplete(poLGTreeview) {
            // Placer les boutons
            actiBasesTreeview_PlaceBoutons(poLGTreeview);

            // Configurer la poignée de redimensionnement entre la DataTable et le form
            //LGTreeview_initGrilleResize("entityFormGrille_DataTable");
        }

        function actiBasesTreeview_CountNodes(poTreeView) {
            var liCnt = 0 ;
            while (true) {
                if (!poTreeView.getNode(liCnt + 1)) {
                    return liCnt ;
                }
                liCnt++ ;
            }
        }
{#        
        
        function actiBasesTreeview_CountNodes(poCurrentNode) {
            var nodes, currentChild ;
            var liCnt = 0 ;
            
            if (typeof poCurrentNode.nodes === "object") {
                // On a fourni un élément (un noeud du treeView
                nodes = poCurrentNode.nodes ;
            } else {
                // On a fourni un tableau (le treeView en entier)
                nodes = poCurrentNode ;
            }
            if (nodes.length > 0) {
                liCnt += nodes.length ;
                for (var i = 0; i < nodes.length; i += 1) {
                    currentChild = nodes[i];
                    liCnt +=actiBasesTreeview_CountNodes(currentChild);
                }
            }
            return liCnt ;
        }
#}        
        // Récupérer un tableau à plat de tous les noeuds du treeView
        function actiBasesTreeview_getAllNodes(psIdElementTreeView){
            var treeViewObject = $('#' + psIdElementTreeView).data('treeview'),
                allCollapsedNodes = treeViewObject.getCollapsed(),
                allExpandedNodes = treeViewObject.getExpanded(),
                allNodes = allCollapsedNodes.concat(allExpandedNodes);

            return allNodes;
        }
        
        // Récupérer l'objet JSON hierarchisé contenant tous les noeuds du TreeView
        function actiBasesTreeview_getData(pvIdElementTreeView){
            var nodes, currentChild ;
            var data = [] ;
            // On a fourni l'id de l'élément TreeView
            var treeViewObject = $('#' + pvIdElementTreeView).treeview(true) ;
            var li = 0 ;
            var li2 = 0 ;
            var node ;
            while (true) {
                node = treeViewObject.getNode(li);
                if (!node) {
                    break ;
                }
                if (!node.cid_parent) {
                    data[li2] = node ;
                    li2 ++ ;
                }
                li++ ;
            }
            return data ;
        }
        function actiBasesTreeview_findNodeInTreeViewObject(psIdElementTreeView, pcType, pcId) {
            // Parcourir les nodes
            var loTreeView = $("#" + psIdElementTreeView).treeview(true) ;
            var liNbNodes = actiBasesTreeview_CountNodes(loTreeView) ;
            var loNode ;
            for (var liNode = liNbNodes; liNode >=0 ; liNode--) {
                loNode = loTreeView.getNode(liNode) ;
                if (loNode.ctype === pcType && loNode.cid === pcId) {
                    return loNode ;
                }
            }
            return null ;
        }
        function actiBasesTreeview_findNodeInTreeViewData(poData, pcType, pcId) {         
            var i, currentChild, result, nodes;

            if (poData.ctype === pcType && poData.cid === pcId) {
                return poData;
            } else {

                // Use a for loop instead of forEach to avoid nested functions
                // Otherwise "return" will not work properly
                if (typeof poData.nodes === "object") {
                    // On a fourni un élément (un noeud du treeView)
                    nodes = poData.nodes ;
                } else {
                    // On a fourni un tableau (le treeView en entier)
                    nodes = poData ;
                }
                for (i = 0; i < nodes.length; i += 1) {
                    currentChild = nodes[i];

                    // Search in the current child
                    result = actiBasesTreeview_findNodeInTreeViewData(currentChild, pcType, pcId);

                    // Return the result if the node has been found
                    if (result !== false) {
                        return result;
                    }
                }

                // The node has not been found and we have no more options
                return false;
            }
        }
        function actiBasesTreeview_addGAB() {
            return actiBasesTreeview_addElement('GAB') ;
        }
        function actiBasesTreeview_addSGAB() {
            return actiBasesTreeview_addElement('SGAB') ;
        }
        function actiBasesTreeview_addAB() {
            return actiBasesTreeview_addElement('AB') ;
        }
        function actiBasesTreeview_addElement(Type) {
//            var treeview = document.getElementById('entityFormTreeview_DataNodes').textContent ;
//            var treeview = $('#entityFormTreeview_DataNodes').text() ;
{#            var treeData = JSON.parse(treeview);#}
            var treeData = actiBasesTreeview_getData('entityFormTreeview_Treeview');
            var selectedNode = $('#entityFormTreeview_Treeview').treeview('getSelected') ;
            if (!selectedNode) {
                // Pas de TreeView ?
                return false ;
            } else if (selectedNode.length == 0) {
                // Pas de noeud sélectionné
                if (Type === 'SGAB') {
                    alert("Pour créer un nouveau sous-groupe, il faut vous placer au préalable sur son groupe, ou sur un sous-groupe de son grouope, ou sur une activité de base de son groupe.") ;
                    return false ;
                } else if (Type === 'AB') {
                    alert("Pour créer une nouvelle activité de base, il faut vous placer au préalable sur son sous-groupe, ou sur une activité de base de son sous-groupe.") ;
                    return false ;                   
                }
            } else {
                // Retrouver la référence au noeud sélectionné dans le tableau "treeData"
                selectedNode = actiBasesTreeview_findNodeInTreeViewData(treeData, selectedNode[0].ctype, selectedNode[0].cid) ;
            }
            var TypeAjout = Type ;
//            var EntityFormTreeview = window.entityFormTreeview ;
        
//            var index = 0;
            var newNode, parentNode;
            //gérer l'exception: si on sélectionne une AB

            if (TypeAjout === 'GAB') {

                newNode = {ctype: 'GAB', cid: 'GAB'
                            , text: 'Nouveau groupe d\'activités de base'
                            , icouleur: 16777215, iid: null, cid_parent: null, nodes: null};
                parentNode = treeData ;
                
            } else if (TypeAjout === 'SGAB') { 

                if (selectedNode.ctype === 'GAB') {
                    parentNode = selectedNode ;
                } else if (selectedNode.ctype === 'SGAB') {
                    parentNode = actiBasesTreeview_findNodeInTreeViewData(treeData, 'GAB', selectedNode.cid_parent) ;
                } else if (selectedNode.ctype === 'AB') {
                    parentNode = actiBasesTreeview_findNodeInTreeViewData(treeData, 'SGAB', selectedNode.cid_parent) ;
                    if (parentNode) {    
                        parentNode = actiBasesTreeview_findNodeInTreeViewData(treeData, 'GAB', parentNode.cid_parent) ;
                    }
                }
                newNode = {ctype: 'SGAB', cid: 'SGAB'
                            , text: 'Nouveau sous-groupe d\'activités de base'
                            , icouleur: 16777215, iid: 21, cid_parent: parentNode.cid, nodes: null};
                        
            } else if (TypeAjout === 'AB') {
                if (selectedNode.ctype === 'GAB') {
                    alert("Pour créer une nouvelle activité de base, il faut vous placer au préalable sur son sous-groupe, ou sur une activité de base de son sous-groupe.") ;
                    return false ;
                } else if (selectedNode.ctype === 'SGAB') {
                    parentNode = selectedNode ;
                } else if (selectedNode.ctype === 'AB') {
                    parentNode = actiBasesTreeview_findNodeInTreeViewData(treeData, 'SGAB', selectedNode.cid_parent) ;
                }
                newNode = {ctype: 'AB', cid: 'AB', text: 'Nouvelle activité de base'
                            , icouleur: 16777215, iid: 21, cid_parent: parentNode.cid};
            }
            
            if (!parentNode) {
                // Le noeud parent n'a pas été retrouvé
                return false ;
            } else if (parentNode === treeData) {
                treeData[treeData.length] = newNode;
            } else {
                if (typeof parentNode.nodes === 'undefined' || parentNode.nodes === null) {
                    // Le noeud parent n'a pas de sous-noeuds : les créer maintenant
                  parentNode.nodes = [];
                }
                parentNode.nodes[parentNode.nodes.length] = newNode;
            }

            // Remove le treeView
            $('#entityFormTreeview_Treeview').treeview('remove');
            // Création du treeView
            LGTreeview_initTree('entityFormTreeview_Treeview', treeData, window.entityFormTreeview, window.entityFormTreeview.onInitComplete);
            
            // reveal la nouvelle node
            var result = actiBasesTreeview_findNodeInTreeViewObject('entityFormTreeview_Treeview', TypeAjout, newNode.cid) ;
            $('#entityFormTreeview_Treeview').treeview('revealNode', [result, {silent: true}]);
//            $('#entityFormTreeview_Treeview').treeview('selectNode', [result]);
            $('#entityFormTreeview_Treeview').treeview('toggleNodeSelected', [result]);

// LG 20200813 déac            $('body').append('<div id="isNewNode" ></div>');
// LG 20200813 : ce code semble inutile début
            $('body').append('<div id="idGroupe" style="display:none;"></div>');
            if (TypeAjout === 'SGAB') {
                $('#idGroupe').text(newNode.cid_parent.substr(3));
            } else if (TypeAjout === 'AB') {
                $('#idGroupe').text(newNode.cid_parent.substr(4));
            }
// LG 20200813 : ce code semble inutile fin

            // Eemplir les champs du formulaire
            var loData = {cnom: newNode.text, cnomcourt: newNode.text, igroupe: newNode.cid_parent, icouleur: newNode.icouleur, ietablissement: -1} ;
            if (TypeAjout === 'AB') {
                loData.isousgroupe = parseInt(newNode.cid_parent.replace("SGAB", "")) ;
                loData.ccode = "NAB" ;
                loData.npriorite = 2 ;
                loData.lconcinterv = true ;
                loData.ltousintervenants = true ;
                loData.lconcusag = true ;
                loData.ltoususagers = true ;
                loData.lconcgroup = true ;
                loData.ltousgroupes = true ;
                loData.lconcsalle = true ;
                loData.ltoutessalles = true ;
            } else if (TypeAjout === 'SGAB') {
                loData.igroupe = parseInt(newNode.cid_parent.replace("GAB", "")) ;
            }

            // Créer les éléments HTML du formulaire, pour le cas où il n'existe pas encore
            // Et y injecter les informations du nouveau noeud
            window.entityFormTreeview.DoLoadData(TypeAjout      // psId
                                                    , true      // pbMêmeSiEnAttente
                                                    , null      // psOnglet
                                                    , true      // pbPourNouveau
                                                    , loData    // poDataPourNouveau
                                                    );
        };
        
        function actiBasesTreeview_PlaceBoutons(poLGTreeview) {
            // on vérifie si les boutons ne sont pas déjà présents
            if ($('#ctnCmdNouvelleActiviteBase_actiBaseSousGroupeGroupe').length === 0) {
                //bouton nouveau groupe
                //id = ctnCmdNouveauGroupe_actiBaseSousGroupeGroupe
                var NouveauGroupe = "<div class=\"form-group grp-btn-spe\" id=\"ctnCmdNouveauGroupe_actiBaseSousGroupeGroupe\">\
                                        <button id=\"bNouveauGroupe_actiBaseSousGroupeGroupe\" class = \"btn-block btn\" style=\"white-space: inherit ! important;\">\
                                            Nouveau groupe\
                                            <span class=\"pull-right\">\
                                                <span class=\"glyphicon glyphicon-file\">\
                                                </span>\
                                            </span>\
                                        </button>\
                                    </div>";
                //bouton nouveau sous-groupe
                //id = ctnCmdNouveauSousGroupe_actiBaseSousGroupeGroupe
                var NouveauSousGroupe = "<div class=\"form-group grp-btn-spe\" id=\"ctnCmdNouveauSousGroupe_actiBaseSousGroupeGroupe\">\
                                            <button id=\"bNouveauSousGroupe_actiBaseSousGroupeGroupe\" class = \"btn-block btn\" style=\"white-space: inherit ! important;\">\
                                                Nouveau sous-groupe\
                                                <span class=\"pull-right\">\
                                                    <span class=\"glyphicon glyphicon-file\">\
                                                    </span>\
                                                </span>\
                                            </button>\
                                        </div>";
                //bouton nouvelle activité de base
                //id = ctnCmdNouvelleActiviteBase_actiBaseSousGroupeGroupe
                var NouvelleActiviteBase = "<div class=\"form-group grp-btn-spe\" id=\"ctnCmdNouvelleActiviteBase_actiBaseSousGroupeGroupe\">\
                                                <button id=\"bNouvelleActiviteBase_actiBaseSousGroupeGroupe\" class = \"btn-block btn\" style=\"white-space: inherit ! important;\">\
                                                    Nouvelle activité de base\
                                                    <span class=\"pull-right\">\
                                                        <span class=\"glyphicon glyphicon-file\">\
                                                        </span>\
                                                    </span>\
                                                </button>\
                                            </div>";
                $('#ctnBoutons_Boutons').prepend(NouveauGroupe, NouveauSousGroupe, NouvelleActiviteBase);
                $('#ctnCmdNouveau_actiBaseSousGroupeGroupe').hide();

                // Gestionnaire du clic sur nouveau groupe
                $('#bNouveauGroupe_actiBaseSousGroupeGroupe').click(/*poLGTreeview.*/actiBasesTreeview_addGAB);

                // Gestionnaire du clic sur nouveau sous-groupe
                $('#bNouveauSousGroupe_actiBaseSousGroupeGroupe').click(/*poLGTreeview.*/actiBasesTreeview_addSGAB);

                // Gestionnaire du clic sur nouvelle activité de base
                $('#bNouvelleActiviteBase_actiBaseSousGroupeGroupe').click(/*poLGTreeview.*/actiBasesTreeview_addAB);
            }
        }
// LG 20200812 fin

//MC 20200908 DEBUT
if(window.innerWidth > 992){
    Split(['.spliteA', '.spliteB'], {
        gutterSize: 5,
        sizes: [23, 77],
        minSize: [200, 980]
    });};
//MC 20200908

    </script>
{% endblock %}
